package com.alterdekim.hearthhack.util;

import com.alterdekim.PegasusGame;
import com.alterdekim.hearthhack.game.GameTag;
import com.alterdekim.hearthhack.game.TagZone;
import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.RequiredArgsConstructor;

import java.util.List;
import java.util.stream.Collectors;

@Getter
@RequiredArgsConstructor
public class GameDeck {
    private final List<PegasusGame.PowerHistoryEntity> deck;

    public void updateCard(PegasusGame.PowerHistoryEntity b) {
        deck.removeIf(c -> c.getName().equals(b.getName()));
        deck.add(b);
    }

    public List<PegasusGame.PowerHistoryEntity> getHandCards() {
        return getCardsByTag(GameTag.ZONE, TagZone.HAND.ordinal());
    }

    public List<PegasusGame.PowerHistoryEntity> getCardsByTag(GameTag tag, Integer val) {
        return deck
                .stream()
                .filter(c -> c.getTagsList()
                        .stream()
                        .anyMatch(f -> f.getName() == tag.getValue() && f.getValue() == val)
                )
                .collect(Collectors.toList());
    }
}
